/*
*         OpenPBS (Portable Batch System) v2.3 Software License
*
* Copyright (c) 1999-2010 Veridian Information Solutions, Inc.
* All rights reserved.
*
* ---------------------------------------------------------------------------
* For a license to use or redistribute the OpenPBS software under conditions
* other than those described below, or to purchase support for this software,
* please contact Veridian Systems, PBS Products Department ("Licensor") at:
*
*    www.OpenPBS.org  +1 650 967-4675                  sales@OpenPBS.org
*                        877 902-4PBS (US toll-free)
* ---------------------------------------------------------------------------
*
* This license covers use of the OpenPBS v2.3 software (the "Software") at
* your site or location, and, for certain users, redistribution of the
* Software to other sites and locations.  Use and redistribution of
* OpenPBS v2.3 in source and binary forms, with or without modification,
* are permitted provided that all of the following conditions are met.
* After December 31, 2001, only conditions 3-6 must be met:
*
* 1. Commercial and/or non-commercial use of the Software is permitted
*    provided a current software registration is on file at www.OpenPBS.org.
*    If use of this software contributes to a publication, product, or
*    service, proper attribution must be given; see www.OpenPBS.org/credit.html
*
* 2. Redistribution in any form is only permitted for non-commercial,
*    non-profit purposes.  There can be no charge for the Software or any
*    software incorporating the Software.  Further, there can be no
*    expectation of revenue generated as a consequence of redistributing
*    the Software.
*
* 3. Any Redistribution of source code must retain the above copyright notice
*    and the acknowledgment contained in paragraph 6, this list of conditions
*    and the disclaimer contained in paragraph 7.
*
* 4. Any Redistribution in binary form must reproduce the above copyright
*    notice and the acknowledgment contained in paragraph 6, this list of
*    conditions and the disclaimer contained in paragraph 7 in the
*    documentation and/or other materials provided with the distribution.
*
* 5. Redistributions in any form must be accompanied by information on how to
*    obtain complete source code for the OpenPBS software and any
*    modifications and/or additions to the OpenPBS software.  The source code
*    must either be included in the distribution or be available for no more
*    than the cost of distribution plus a nominal fee, and all modifications
*    and additions to the Software must be freely redistributable by any party
*    (including Licensor) without restriction.
*
* 6. All advertising materials mentioning features or use of the Software must
*    display the following acknowledgment:
*
*     "This product includes software developed by NASA Ames Research Center,
*     Lawrence Livermore National Laboratory, and Veridian Information
*     Solutions, Inc.
*     Visit www.OpenPBS.org for OpenPBS software support,
*     products, and information."
*
* 7. DISCLAIMER OF WARRANTY
*
* THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND. ANY EXPRESS
* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
* OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT
* ARE EXPRESSLY DISCLAIMED.
*
* IN NO EVENT SHALL VERIDIAN CORPORATION, ITS AFFILIATED COMPANIES, OR THE
* U.S. GOVERNMENT OR ANY OF ITS AGENCIES BE LIABLE FOR ANY DIRECT OR INDIRECT,
* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
* OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* This license will be governed by the laws of the Commonwealth of Virginia,
* without reference to its choice of law rules.
*/

#include "alps_constants.h"


const int   apbasil_fail_transient = -10;
const int   apbasil_fail_permanent = -11;
const char *message                = "Message";
const char *response_data          = "ResponseData";
const char *compute_unit_array     = "ComputeUnitArray";
const char *compute_unit           = "ComputeUnit";
const char *socket_array           = "SocketArray";
const char *socket_name            = "Socket";
const char *system_tag             = "System";
const char *nodes_element          = "Nodes";
const char *node_array             = "NodeArray";
const char *node_name              = "Node";
const char *reservation_array      = "ReservationArray";
const char *name                   = "name";
const char *node_id                = "node_id";
const char *architecture           = "architecture";
const char *state                  = "state";
const char *role                   = "role";
const char *batch_caps             = "BATCH";
const char *success                = "SUCCESS";
const char *status                 = "status";
const char *clock_mhz              = "clock_mhz";
const char *reservation_id         = "reservation_id";
const char *processor_array        = "ProcessorArray";
const char *processor              = "Processor";
const char *ProcessorAllocation    = "ProcessorAllocation";
const char *memory_array           = "MemoryArray";
const char *memory_name            = "Memory";
const char *label_array            = "LabelArray";
const char *segment_array          = "SegmentArray";
const char *segment                = "Segment";
const char *accelerator_array      = "AcceleratorArray";
const char *accelerator            = "Accelerator";
const char *ordinal                = "ordinal";
const char *type                   = "type";
const char *text_name              = "text";
const char *memory_mb              = "memory_mb";
const char *family                 = "family";
const char *cproc_eq               = "CPROC=";
const int   ac_cproc_eq_len        = 6;
const char *ccu_eq                 = "CCU=";
const int   ac_ccu_eq_len          = 4;
const char *CRAY_GPU_STATUS_START  = "<cray_gpu_status>";
const char *CRAY_GPU_STATUS_END    = "</cray_gpu_status>";
const char *alps_reporter_feature  = "alps_reporter";
const char *alps_starter_feature   = "alps_login";
const char *reserved               = "Reserved";
const char *pagg_id                = "pagg_id";
const char *admin_cookie           = "admin_cookie";
const char *error_class            = "error_class";
const char *numa_config            = "numa_cfg";
const char *hbm_cache_pct          = "hbm_cache_pct";
const char *hbm_size               = "hbm_size_mb";
const char *page_size_kb           = "page_size_kb";
const char *page_count             = "page_count";
const char *numas                  = "numa_nodes";


